#pragma config(Sensor, port1,   FbumpSwitch,    sensorVexIQ_Touch)
#pragma config(Sensor, port2,   FRtouch_LED,    sensorVexIQ_LED)
#pragma config(Sensor, port3,   BRbumpSwitch,   sensorVexIQ_Touch)
#pragma config(Sensor, port4,   MRtouch_LED,    sensorVexIQ_LED)
#pragma config(Sensor, port5,   BRtouch_LED,    sensorVexIQ_LED)
#pragma config(Motor,  motor6,  FLMotor,        tmotorVexIQ, openLoop, encoder)
#pragma config(Motor,  motor7,  FRMotor,        tmotorVexIQ, openLoop, encoder)
#pragma config(Sensor, port8,   MLtouch_LED,    sensorVexIQ_LED)
#pragma config(Sensor, port9,   BLbumpSwitch,   sensorVexIQ_Touch)
#pragma config(Sensor, port10,  FLtouch_LED,    sensorVexIQ_LED)
#pragma config(Motor,  motor11, BMotor,         tmotorVexIQ, openLoop, encoder)
#pragma config(Sensor, port12,  BLtouch_LED,      sensorVexIQ_LED)


int FLSpeed = 0;
int FRSpeed = 0;
int BSpeed = 0;
int driveMode = 7;
int touchMode = 1;
int lastCase = 0;
int waitR [1];
int oldTouch = 0;
int newTouch = 0;
int counter = 0;
int counter2 = 0;
int FRbrightValue = 0;
int MRbrightValue = 0;
int BRbrightValue = 0;
int BLbrightValue = 0;
int MLbrightValue = 0;
int FLbrightValue = 0;
float spiralWait = 0;
float x = 0;
float y = 0;
float turnRot = 0;
bool BlBump = false;
bool BrBump = false;
bool FBump = false;


task main()
{
	setMotorEncoderUnits(encoderDegrees);
	waitR[0]=0;

	//loading circle--------------------------------------------------------------------------------------------------------------------------------
	for( int i=0; i<7; i=i+1)
	{
		setTouchLEDBrightness(FRtouch_LED, FRbrightValue); //shift brightness
		setTouchLEDBrightness(MRtouch_LED, MRbrightValue);
		setTouchLEDBrightness(BRtouch_LED, BRbrightValue);
		setTouchLEDBrightness(BLtouch_LED, BLbrightValue);
		setTouchLEDBrightness(MLtouch_LED, MLbrightValue);
		setTouchLEDBrightness(FLtouch_LED, FLbrightValue);
		counter = counter+1;
		switch(counter)
		{
			case 1:
				setTouchLEDHue(BLtouch_LED, 14.2);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 255;
				BRbrightValue = 0;
			break;

			case 2:
				setTouchLEDHue(MLtouch_LED, 28.3);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 255;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 3:
				setTouchLEDHue(FLtouch_LED, 42.5);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 4:
				setTouchLEDHue(FRtouch_LED, 56.7);
				FRbrightValue = 255;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 5:
				setTouchLEDHue(MRtouch_LED, 71);
				FRbrightValue = 0;
 				MRbrightValue = 255;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 6:
				setTouchLEDHue(BRtouch_LED, 85.1);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 255;
			break;

			default:
			break;
		}

		sleep(250);
	}
		sleep(500);
//end start up--------------------------------------------------------------------------------------------------------------------------------------------------
	while(true)
	{

		srand(nSysTime);//used to base random on system time
		displayCenteredBigTextLine(1, "KIWI BOT");//print to screen
		displayCenteredTextLine(3, "Press LEDs to");
		displayCenteredTextLine(4, "slow or stop.");
//TouchLED touch modes-----------------------------------------------------
		oldTouch = newTouch;
		if(getTouchLEDValue(FRtouch_LED) == 1 || getTouchLEDValue(BRtouch_LED) == 1 || getTouchLEDValue(BLtouch_LED) == 1 || getTouchLEDValue(FLtouch_LED) == 1 || getTouchLEDValue(MRtouch_LED) == 1 || getTouchLEDValue(MLtouch_LED) == 1 )
		{
			newTouch = 1;
		}
		else
		{
			newTouch = 0;
		}
		if(newTouch == 1 && oldTouch != newTouch)
		{

				touchMode++;
			if(touchMode > 3)
			{
				touchMode = 1;
			}
		}
		if(touchMode != 3)//if not stop mode
{
//---------------------------------------------------------------------------
		switch( driveMode )
		{
		case    1:  // Drive Forward--------------------------------------------------------------------------------------------------------------------
		if(touchMode == 1)//prevents conflicted color modes
		{
			setTouchLEDColor(FRtouch_LED, colorRedViolet);//set color
			setTouchLEDColor(BRtouch_LED, colorRedViolet);
			setTouchLEDColor(BLtouch_LED, colorRedViolet);
			setTouchLEDColor(FLtouch_LED, colorRedViolet);
		  setTouchLEDColor(MRtouch_LED, colorRedViolet);
		  setTouchLEDColor(MLtouch_LED, colorRedViolet);
		}

			counter2 = counter2 + 1;//increment both counters
    	if(counter2 > 50)
    	{
    		counter = counter + 1;
    	}

    		switch(counter)//cycle through LEDs
		{
			case 1:
				FRbrightValue = 255;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 2:
				FRbrightValue = 0;
 				MRbrightValue = 255;
 				MLbrightValue = 255;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 3:
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 255;
				BRbrightValue = 255;
			break;

			default:
			break;

		}


			if(counter>3)//reset counter
		{
			counter = 1;
		}
		if(counter < 1)
		{
			counter = 3;
		}
		if(counter2> 50)
		{
			counter2 = 0;
		}

			FLSpeed = 100;
			FRSpeed = -100;
			BSpeed = 0;
			lastCase = 1;//used to ensure last case is not picked twice in a row
			break;

		case    2: // Drive Left-------------------------------------------------------------------------------------------------------------------------
			if(touchMode == 1)//prevents conflicted color modes
			{
			 setTouchLEDColor(FRtouch_LED, colorDarkOrange);
			 setTouchLEDColor(BRtouch_LED, colorDarkOrange);
			 setTouchLEDColor(BLtouch_LED, colorDarkOrange);
		   setTouchLEDColor(FLtouch_LED, colorDarkOrange);
		   setTouchLEDColor(MRtouch_LED, colorDarkOrange);
		   setTouchLEDColor(MLtouch_LED, colorDarkOrange);
      }
			counter2 = counter2 + 1;//increment both counters
    	if(counter2 > 50)
    	{
    		counter = counter + 1;
    	}

    		switch(counter)//cycle through LEDs
		{
			case 1:
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 255;
 				FLbrightValue = 0;
				BLbrightValue = 255;
				BRbrightValue = 0;
			break;

			case 2:
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 255;
			break;

			case 3:
				FRbrightValue = 255;
 				MRbrightValue = 255;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			default:
			break;

		}

			if(counter>3)//reset counters
		{
			counter = 1;
		}
		if(counter < 1)
		{
			counter = 3;
		}
		if(counter2> 50)
		{
			counter2 = 0;
		}

			FLSpeed = -100;
			FRSpeed = 0;
			BSpeed = 100;
			lastCase = 2;


			break;

		case    3: // Drive Right-------------------------------------------------------------------------------------------------------------------------
		if(touchMode == 1)//prevents conflicted color modes
		{
			setTouchLEDColor(FRtouch_LED, colorOrange);
			setTouchLEDColor(BRtouch_LED, colorOrange);
			setTouchLEDColor(BLtouch_LED, colorOrange);
			setTouchLEDColor(FLtouch_LED, colorOrange);
		  setTouchLEDColor(MRtouch_LED, colorOrange);
		  setTouchLEDColor(MLtouch_LED, colorOrange);
    }
		  	counter2 = counter2 + 1;//increment counters
    	if(counter2 > 50)
    	{
    		counter = counter + 1;
    	}

    		switch(counter)//cycle through LEDs
		{
			case 1:
				FRbrightValue = 0;
 				MRbrightValue = 255;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 255;
			break;

			case 2:
				FRbrightValue = 255;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 255;
				BRbrightValue = 0;
			break;

			case 3:
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 255;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			default:
			break;

		}


			if(counter>3)//reset counters
		{
			counter = 1;
		}
		if(counter < 1)
		{
			counter = 3;
		}
		if(counter2> 50)
		{
			counter2 = 0;
		}

			FLSpeed = 0;
			FRSpeed = 100;
			BSpeed = -100;
			lastCase = 3;
			break;

		case    4: // Derp Spin---------------------------------------------------------------------------------------------------------------

     if(touchMode == 1)//prevents conflicted color modes
      {
		  	setTouchLEDColor(FRtouch_LED, colorBlueGreen);
		  	setTouchLEDColor(BRtouch_LED, colorBlueGreen);
		  	setTouchLEDColor(BLtouch_LED, colorBlueGreen);
		  	setTouchLEDColor(FLtouch_LED, colorBlueGreen);
		    setTouchLEDColor(MRtouch_LED, colorBlueGreen);
		    setTouchLEDColor(MLtouch_LED, colorBlueGreen);
		  }
			if(getMotorEncoder(FRMotor)> -460)//spin bot and cycle LEDs
			{
				FLSpeed = -100;
				FRSpeed = -100;
				BSpeed = 0;
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 255;
				BRbrightValue = 255;
			}
			else if(getMotorEncoder(FRMotor)<= -460 && getMotorEncoder(BMotor)> -460 )
			{
				FLSpeed = 0;
				FRSpeed = -100;
				BSpeed = -100;
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 255;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 0;
			}
			else if(getMotorEncoder(BMotor)<= -460 && getMotorEncoder(FLMotor)> -920)
			{
				FLSpeed = -100;
				FRSpeed = 0;
				BSpeed = -100;
		   	FRbrightValue = 255;
 				MRbrightValue = 255;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			}
			else//reset encoders after each complete cycle
			{
				resetMotorEncoder(BMotor);
				resetMotorEncoder(FLMotor);
				resetMotorEncoder(FRMotor);
			}
			lastCase = 4;
			break;

		case    5: // Death Spin--------------------------------------------------------------------------------------------------------------
		 if(touchMode == 1)//prevents conflicted color modes
		 {
			setTouchLEDColor(FRtouch_LED, colorBlue);
			setTouchLEDColor(BRtouch_LED, colorBlue);
			setTouchLEDColor(BLtouch_LED, colorBlue);
			setTouchLEDColor(FLtouch_LED, colorBlue);
		  setTouchLEDColor(MRtouch_LED, colorBlue);
		  setTouchLEDColor(MLtouch_LED, colorBlue);
		}
		  	if(getMotorEncoder(FRMotor)> -420)//cycle motors and LEDs
			{
				FLSpeed = -100;
				FRSpeed = -100;
				BSpeed = -40;
				if(getMotorEncoder(FRMotor)> -210)
				{
				  FRbrightValue = 0;
 			  	MRbrightValue = 0;
 			   	MLbrightValue = 0;
 				  FLbrightValue = 0;
			 	  BLbrightValue = 0;
			  	BRbrightValue = 255;
			  }
			  else
			  {
			  	FRbrightValue = 0;
 			  	MRbrightValue = 0;
 			   	MLbrightValue = 0;
 				  FLbrightValue = 0;
			 	  BLbrightValue = 255;
			  	BRbrightValue = 0;
			  }
		  }

			else if(getMotorEncoder(FRMotor)<= -420 && getMotorEncoder(FRMotor)> -840)
			{
				FLSpeed = -40;
				FRSpeed = -100;
				BSpeed = -100;
				resetMotorEncoder(BMotor);

						if(getMotorEncoder(FRMotor)> -630)
				{
				  FRbrightValue = 0;
 			  	MRbrightValue = 0;
 			   	MLbrightValue = 255;
 				  FLbrightValue = 0;
			 	  BLbrightValue = 0;
			  	BRbrightValue = 0;
			  }
			  else
			  {
			  	FRbrightValue = 0;
 			  	MRbrightValue = 0;
 			   	MLbrightValue = 0;
 				  FLbrightValue = 255;
			 	  BLbrightValue = 0;
			  	BRbrightValue = 0;
			  }
			}
			else if(getMotorEncoder(BMotor)> -420 )
			{
				FLSpeed = -100;
				FRSpeed = -40;
				BSpeed = -100;

					if(getMotorEncoder(BMotor)> -210)
				{
				  FRbrightValue = 255;
 			  	MRbrightValue = 0;
 			   	MLbrightValue = 0;
 				  FLbrightValue = 0;
			 	  BLbrightValue = 0;
			  	BRbrightValue = 0;
			  }
			  else
			  {
			  	FRbrightValue = 0;
 			  	MRbrightValue = 255;
 			   	MLbrightValue = 0;
 				  FLbrightValue = 0;
			 	  BLbrightValue = 0;
			  	BRbrightValue = 0;
			  }
			}
			else//reset encoders after each complete cycle
			{
				resetMotorEncoder(BMotor);
				resetMotorEncoder(FLMotor);
				resetMotorEncoder(FRMotor);
			}

			lastCase = 5;
			break;

		case    6:  // SERPENTINE----------------------------------------------------------------------------------------------------------------------
			FLSpeed = 100;
			FRSpeed = -100;
     if(touchMode == 1)//prevents conflicted color modes
     {
			setTouchLEDColor(FRtouch_LED, colorDarkBlue);
			setTouchLEDColor(BRtouch_LED, colorDarkBlue);
			setTouchLEDColor(BLtouch_LED, colorDarkBlue);
			setTouchLEDColor(FLtouch_LED, colorDarkBlue);
		  setTouchLEDColor(MRtouch_LED, colorDarkBlue);
		  setTouchLEDColor(MLtouch_LED, colorDarkBlue);
		}
			if(getMotorEncoder(BMotor)< -120 || (getMotorEncoder(BMotor)< 10 && BSpeed > -25))//cycle back motor and LEDs
			{
				BSpeed = 50;

				FRbrightValue = 255;
 				MRbrightValue = 60;
 				MLbrightValue = 0;
 				FLbrightValue = 100;
				BLbrightValue = 0;
				BRbrightValue = 0;
			}
			else if (getMotorEncoder(BMotor)> 120)
			{
				BSpeed = -50;
				FRbrightValue = 100;
 				MRbrightValue = 0;
 				MLbrightValue = 60;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 0;
			}

			lastCase = 6;
			break;

				case    7:  //swerve spiral-------------------------------------------------------------------------------------------------------------
		 if(touchMode == 1)//prevents conflicted color modes
		 {
			setTouchLEDColor(FRtouch_LED, colorViolet);
			setTouchLEDColor(BRtouch_LED, colorViolet);
			setTouchLEDColor(BLtouch_LED, colorViolet);
			setTouchLEDColor(FLtouch_LED, colorViolet);
		  setTouchLEDColor(MRtouch_LED, colorViolet);
		  setTouchLEDColor(MLtouch_LED, colorViolet);
		}
		  //Set LEDs based off degrees------------------------------------------------------
		  if(x <= 45)
		{
		  FLbrightValue = 0;
 			FRbrightValue = 0;
 			MRbrightValue = 0;
 			BRbrightValue = 0;
			BLbrightValue = x * 5.66;
			MLbrightValue = 255-(x * 5.66);
		}

		if(x >45 && x <= 90)
		{
 			MLbrightValue = 0;
		  FLbrightValue = 0;
 			FRbrightValue = 0;
 			MRbrightValue = 0;
			BLbrightValue = 255-(x * 1.41);
			BRbrightValue = (x-45) * 1.41;
		}


		if(x >90 && x <= 135)
		{
 			MLbrightValue = 0;
		  FLbrightValue = 0;
 			FRbrightValue = 0;
 			MRbrightValue = 0;
			BLbrightValue = 127.5-((x-90) * 2.83);
			BRbrightValue = (x -90) * 5.66;
		}

		if(x >135 && x <= 180)
		{
			BLbrightValue = 0;
 			MLbrightValue = 0;
		  FLbrightValue = 0;
 			FRbrightValue = 0;
			BRbrightValue = 255-((x-135) * 5.66);
			MRbrightValue = (x-135) * 5.66;
		}
		if(x >180 && x <= 225)
		{
			BLbrightValue = 0;
 			MLbrightValue = 0;
		  FLbrightValue = 0;
 			FRbrightValue = (x -180) * 5.66;
			BRbrightValue = 0;
			MRbrightValue = 255-((x-180) * 5.66);
		}

		if(x >225 && x <= 270)
		{
			BLbrightValue = 0;
 			MLbrightValue = 0;
 			MRbrightValue = 0;
 			BRbrightValue = 0;
			FRbrightValue = 255-(x * 1.41);
			FLbrightValue = (x-225) * 1.41;
		}

		if(x >270 && x <= 315)
		{
			BLbrightValue = 0;
 			MLbrightValue = 0;
 			MRbrightValue = 0;
 			BRbrightValue = 0;
			FRbrightValue = 127.5-((x-270) * 2.83);
			FLbrightValue = (x -270) * 5.66;
		}

		if(x >315)
		{
			BLbrightValue = 0;
 			FRbrightValue = 0;
 			MRbrightValue = 0;
 			BRbrightValue = 0;
			FLbrightValue = 255-((x-315) * 5.66);
			MLbrightValue = (x-315) * 5.66;
		}
//----------------------------------------------------

    waitR[0] = waitR[0]+100;//1

    if(waitR[0] > spiralWait)//increment the time spent on each degree
    {
    	waitR[0] = 0;
    	spiralWait = spiralWait+ .1;//.5
    	x = x + 1;//x and y are the desired degrees
    	y = y + 1;
    }

    if(x>360)
    {
    	x=0;
    }
   if(y>360)
   {
    	y=0;
    }
		/*Original Formulas
		wheelSpeed[0] = y*sqrt(3)/2 + x/2 + r; // front-left
    wheelSpeed[1] = y*sqrt(3)/2 - x/2 - r; // front-right
    wheelSpeed[2] = x - r; // back-middle*/
//turn deg into motor values
    FLSpeed = -(sinDegrees(y)*100)*sqrt(3)/2 - (cosDegrees(x)*100)/2 + 0; // front-left
    FRSpeed  = (sinDegrees(y)*100)*sqrt(3)/2 - (cosDegrees(x)*100)/2 - 0; // front-right
    BSpeed = (cosDegrees(x)*100) - 0; // back-middle

			lastCase = 7;
			break;

		case    8: // rand turn------------------------------------------------------------------------------------------------------------------------------


			waitR[0]=0;
			spiralWait = 20;

			if(getMotorEncoder(BMotor)< turnRot)//Perform a turn of random degrees
			{
				FLSpeed = 100;
				FRSpeed = 100;
				BSpeed = 100;
			}
			else
			{
				resetMotorEncoder(BMotor);
		  	resetMotorEncoder(FLMotor);
		    resetMotorEncoder(FRMotor);

				driveMode = (random[6]+1);
				while(driveMode == lastCase)//ensure the same mode is not used twice in a row
					driveMode = (random[6]+1);
				}

				setTouchLEDBlinkTime(FRtouch_LED, 20, 0);
				setTouchLEDBlinkTime(BRtouch_LED, 20, 0);
				setTouchLEDBlinkTime(BLtouch_LED, 20, 0);
				setTouchLEDBlinkTime(FLtouch_LED, 20, 0);
				setTouchLEDBlinkTime(MRtouch_LED, 20, 0);
				setTouchLEDBlinkTime(MLtouch_LED, 20, 0);
			break;

			case 9://dummy case

			break;

		default:

			break;
		}


		if(getBumperValue(FbumpSwitch) == 1 )//bumper switches------------------------------------------------------------------------------------------------
		{
			driveMode = 9;
			setTouchLEDColor(FRtouch_LED, colorRed);
			setTouchLEDColor(FLtouch_LED, colorRed);
			setTouchLEDBlinkTime(FRtouch_LED, 1, 1);
			setTouchLEDBlinkTime(BRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(BLtouch_LED, 3, 3);
			setTouchLEDBlinkTime(FLtouch_LED, 1, 1);
			setTouchLEDBlinkTime(MRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(MLtouch_LED, 3, 3);
			FRbrightValue = 255;
 			MRbrightValue = 255;
 			MLbrightValue = 255;
 			FLbrightValue = 255;
			BLbrightValue = 255;
			BRbrightValue = 255;

			FBump = true;
			BlBump = false;
			BrBump = false;
		}

		if(getBumperValue(BLbumpSwitch) == 1)
		{
			driveMode =9;
			setTouchLEDColor(BLtouch_LED, colorRed);
			setTouchLEDColor(MLtouch_LED, colorRed);
			setTouchLEDBlinkTime(FRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(BRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(BLtouch_LED, 1, 1);
			setTouchLEDBlinkTime(FLtouch_LED, 3, 3);
			setTouchLEDBlinkTime(MRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(MLtouch_LED, 1, 1);
			FRbrightValue = 255;
 			MRbrightValue = 255;
 			MLbrightValue = 255;
 			FLbrightValue = 255;
			BLbrightValue = 255;
			BRbrightValue = 255;

			BlBump = true;
			FBump = false;
			BrBump = false;
		}

		if(getBumperValue(BRbumpSwitch) == 1)
		{
			driveMode = 9;
			setTouchLEDColor(BRtouch_LED, colorRed);
			setTouchLEDColor(MRtouch_LED, colorRed);
			setTouchLEDBlinkTime(FRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(BRtouch_LED, 1, 1);
			setTouchLEDBlinkTime(BLtouch_LED, 3, 3);
			setTouchLEDBlinkTime(FLtouch_LED, 3, 3);
			setTouchLEDBlinkTime(MRtouch_LED, 1, 1);
			setTouchLEDBlinkTime(MLtouch_LED, 3, 3);
			FRbrightValue = 255;
 			MRbrightValue = 255;
 			MLbrightValue = 255;
 			FLbrightValue = 255;
			BLbrightValue = 255;
			BRbrightValue = 255;

			BrBump = true;
			FBump = false;
			BlBump = false;
		}

		if(FBump == true)
		{
			if(getMotorEncoder(FRMotor)< 180)
			{
				FLSpeed = -100;
				FRSpeed = 100;
				BSpeed = 0;
			}
			else
			{
				FBump = false;
				resetMotorEncoder(BMotor);
				driveMode =8;
				turnRot =	(random[724]+360);
				resetMotorEncoder(BMotor);
			  resetMotorEncoder(FLMotor);
		  	resetMotorEncoder(FRMotor);
			}
		}

		if(BlBump == true)
		{
			if(getMotorEncoder(FLMotor)< 180)
			{
				FLSpeed = 100;
				FRSpeed = 0;
				BSpeed = -100;
			}
			else
			{
				BlBump = false;
				resetMotorEncoder(BMotor);
				driveMode =8;
		  	turnRot =	(random[724]+360);
			  resetMotorEncoder(BMotor);
			  resetMotorEncoder(FLMotor);
			  resetMotorEncoder(FRMotor);
			}
		}

		if(BrBump == true)
		{
			if(getMotorEncoder(BMotor)< 180)
			{
				FLSpeed = 0;
				FRSpeed = -100;
				BSpeed = 100;
			}
			else
			{
				BrBump = false;
				resetMotorEncoder(BMotor);
				driveMode =8;
		  	turnRot =	(random[724]+360);
				resetMotorEncoder(BMotor);
		  	resetMotorEncoder(FLMotor);
		  	resetMotorEncoder(FRMotor);
			}
		}

//LED Color----------------------------------------------------------------------------------------------------------------------------------


    setTouchLEDBrightness(FRtouch_LED, FRbrightValue); //set brightness
		setTouchLEDBrightness(MRtouch_LED, MRbrightValue);
		setTouchLEDBrightness(BRtouch_LED, BRbrightValue);
		setTouchLEDBrightness(BLtouch_LED, BLbrightValue);
		setTouchLEDBrightness(MLtouch_LED, MLbrightValue);
		setTouchLEDBrightness(FLtouch_LED, FLbrightValue);

//slow/stop mode-----------------------------------------------------------------------------------------------------------------------------
	}
		if(touchMode == 2)//slow mode
		{
			setTouchLEDColor(FRtouch_LED, colorYellow);
			setTouchLEDColor(BRtouch_LED, colorYellow);
			setTouchLEDColor(BLtouch_LED, colorYellow);
			setTouchLEDColor(FLtouch_LED, colorYellow);
		  setTouchLEDColor(MRtouch_LED, colorYellow);
		  setTouchLEDColor(MLtouch_LED, colorYellow);

			FLSpeed = FLSpeed/2;
			FRSpeed = FRSpeed/2;
			BSpeed = BSpeed/2;
		}

			if(touchMode == 3)//stop mode
		{
			setTouchLEDColor(FRtouch_LED, colorRed);
			setTouchLEDColor(BRtouch_LED, colorRed);
			setTouchLEDColor(BLtouch_LED, colorRed);
			setTouchLEDColor(FLtouch_LED, colorRed);
		  setTouchLEDColor(MRtouch_LED, colorRed);
		  setTouchLEDColor(MLtouch_LED, colorRed);

		  setTouchLEDBrightness(FRtouch_LED, 255); //shift brightness
		  setTouchLEDBrightness(MRtouch_LED, 255);
		  setTouchLEDBrightness(BRtouch_LED, 255);
	 	  setTouchLEDBrightness(BLtouch_LED, 255);
		  setTouchLEDBrightness(MLtouch_LED, 255);
		  setTouchLEDBrightness(FLtouch_LED, 255);

			FLSpeed = 0;
			FRSpeed = 0;
			BSpeed = 0;
		}
//------------------------------------------------------------------------------------------------------------------------------

		setMotorSpeed(FLMotor, FLSpeed); //run motors
		setMotorSpeed(FRMotor, FRSpeed);
		setMotorSpeed(BMotor,  BSpeed);
	}
}
