#pragma config(Sensor, port1,   FbumpSwitch,    sensorVexIQ_Touch)
#pragma config(Sensor, port2,   FRtouch_LED,    sensorVexIQ_LED)
#pragma config(Sensor, port3,   BRbumpSwitch,   sensorVexIQ_Touch)
#pragma config(Sensor, port4,   MRtouch_LED,    sensorVexIQ_LED)
#pragma config(Sensor, port5,   BRtouch_LED,    sensorVexIQ_LED)
#pragma config(Motor,  motor6,  FLMotor,        tmotorVexIQ, openLoop, encoder)
#pragma config(Motor,  motor7,  FRMotor,        tmotorVexIQ, openLoop, encoder)
#pragma config(Sensor, port8,   MLtouch_LED,    sensorVexIQ_LED)
#pragma config(Sensor, port9,   BLbumpSwitch,   sensorVexIQ_Touch)
#pragma config(Sensor, port10,  FLtouch_LED,    sensorVexIQ_LED)
#pragma config(Motor,  motor11, BMotor,         tmotorVexIQ, openLoop, encoder)
#pragma config(Sensor, port12,  BLtouch_LED,      sensorVexIQ_LED)

int FLSpeed = 0;
int FRSpeed = 0;
int BSpeed = 0;
int waitR [1];
int FRbrightValue = 0;
int MRbrightValue = 0;
int BRbrightValue = 0;
int BLbrightValue = 0;
int MLbrightValue = 0;
int FLbrightValue = 0;
int counter = 0;
float x = 0;
float y = 0;
bool BlBump = false;
bool BrBump = false;
bool FBump = false;


task main()
{
	setMotorEncoderUnits(encoderDegrees);
	waitR[0]=0;

	//loading circle--------------------------------------------------------------------------------------------------------------------------------
	for( int i=0; i<7; i=i+1)
	{
		setTouchLEDBrightness(FRtouch_LED, FRbrightValue); //shift brightness
		setTouchLEDBrightness(MRtouch_LED, MRbrightValue);
		setTouchLEDBrightness(BRtouch_LED, BRbrightValue);
		setTouchLEDBrightness(BLtouch_LED, BLbrightValue);
		setTouchLEDBrightness(MLtouch_LED, MLbrightValue);
		setTouchLEDBrightness(FLtouch_LED, FLbrightValue);
		counter = counter+1;
		switch(counter)
		{
			case 1:
				setTouchLEDHue(BLtouch_LED, 14.2);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 255;
				BRbrightValue = 0;
			break;

			case 2:
				setTouchLEDHue(MLtouch_LED, 28.3);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 255;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 3:
				setTouchLEDHue(FLtouch_LED, 42.5);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 4:
				setTouchLEDHue(FRtouch_LED, 56.7);
				FRbrightValue = 255;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 5:
				setTouchLEDHue(MRtouch_LED, 71);
				FRbrightValue = 0;
 				MRbrightValue = 255;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 6:
				setTouchLEDHue(BRtouch_LED, 85.1);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 255;
			break;

			default:
			break;
		}

		sleep(250);
	}

		sleep(500);
//--------------------------------------------------------------------------------------------------------------------------------------------------


	while(true)
	{
		srand(nSysTime);
		displayCenteredBigTextLine(1, "KIWI BOT");
		displayCenteredTextLine(4, "Follows Circular Path");

		setTouchLEDColor(FRtouch_LED, colorViolet);//set color
		setTouchLEDColor(BRtouch_LED, colorViolet);
		setTouchLEDColor(BLtouch_LED, colorViolet);
		setTouchLEDColor(FLtouch_LED, colorViolet);
	  setTouchLEDColor(MRtouch_LED, colorViolet);
	  setTouchLEDColor(MLtouch_LED, colorViolet);


    waitR[0] = waitR[0]+1;

    if(waitR[0] > 2)
    {
    	waitR[0] = 0;
    	x = x + 1;// increment degrees of motion
    	y = y + 1;
    }

    if(x>360)
    {
    	x=0;
    }
   if(y>360)
   {
    	y=0;
   }

		/*
		wheelSpeed[0] = y*sqrt(3)/2 + x/2 + r; // front-left
    wheelSpeed[1] = y*sqrt(3)/2 - x/2 - r; // front-right
    wheelSpeed[2] = x - r; // back-middle
    */
//convets desired degree of motion into wheel power
    FLSpeed = -(sinDegrees(y)*100)*sqrt(3)/2 - (cosDegrees(x)*100)/2 + 0; // front-left
    FRSpeed  = (sinDegrees(y)*100)*sqrt(3)/2 - (cosDegrees(x)*100)/2 - 0; // front-right
    BSpeed = (cosDegrees(x)*100) - 0; // back-middle

//------------------------------------------------------------------------------------------
//Set LEDs based off of motion----------------------------------------------------------------------------------------------------------
     if(x <= 45)
		{
		  FLbrightValue = 0;
 			FRbrightValue = 0;
 			MRbrightValue = 0;
 			BRbrightValue = 0;
			BLbrightValue = x * 5.66;
			MLbrightValue = 255-(x * 5.66);
		}

		if(x >45 && x <= 90)
		{
 			MLbrightValue = 0;
		  FLbrightValue = 0;
 			FRbrightValue = 0;
 			MRbrightValue = 0;
			BLbrightValue = 255-(x * 1.41);
			BRbrightValue = (x-45) * 1.41;
		}


		if(x >90 && x <= 135)
		{
 			MLbrightValue = 0;
		  FLbrightValue = 0;
 			FRbrightValue = 0;
 			MRbrightValue = 0;
			BLbrightValue = 127.5-((x-90) * 2.83);
			BRbrightValue = (x -90) * 5.66;
		}

		if(x >135 && x <= 180)
		{
			BLbrightValue = 0;
 			MLbrightValue = 0;
		  FLbrightValue = 0;
 			FRbrightValue = 0;
			BRbrightValue = 255-((x-135) * 5.66);
			MRbrightValue = (x-135) * 5.66;
		}
		if(x >180 && x <= 225)
		{
			BLbrightValue = 0;
 			MLbrightValue = 0;
		  FLbrightValue = 0;
 			FRbrightValue = (x -180) * 5.66;
			BRbrightValue = 0;
			MRbrightValue = 255-((x-180) * 5.66);
		}

		if(x >225 && x <= 270)
		{
			BLbrightValue = 0;
 			MLbrightValue = 0;
 			MRbrightValue = 0;
 			BRbrightValue = 0;
			FRbrightValue = 255-(x * 1.41);
			FLbrightValue = (x-225) * 1.41;
		}

		if(x >270 && x <= 315)
		{
			BLbrightValue = 0;
 			MLbrightValue = 0;
 			MRbrightValue = 0;
 			BRbrightValue = 0;
			FRbrightValue = 127.5-((x-270) * 2.83);
			FLbrightValue = (x -270) * 5.66;
		}

		if(x >315)
		{
			BLbrightValue = 0;
 			FRbrightValue = 0;
 			MRbrightValue = 0;
 			BRbrightValue = 0;
			FLbrightValue = 255-((x-315) * 5.66);
			MLbrightValue = (x-315) * 5.66;
		}
//--------------------------------------------------------------------------------------------------------------------------------------------
		if(getBumperValue(FbumpSwitch) == 1 )//bumper switches------------------------------------------------------------------------------------------------
		{
			setTouchLEDColor(FRtouch_LED, colorRed);
			setTouchLEDColor(FLtouch_LED, colorRed);
			setTouchLEDBlinkTime(FRtouch_LED, 1, 1);
			setTouchLEDBlinkTime(BRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(BLtouch_LED, 3, 3);
			setTouchLEDBlinkTime(FLtouch_LED, 1, 1);
			setTouchLEDBlinkTime(MRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(MLtouch_LED, 3, 3);
			FRbrightValue = 255;
 			MRbrightValue = 255;
 			MLbrightValue = 255;
 			FLbrightValue = 255;
			BLbrightValue = 255;
			BRbrightValue = 255;

			FBump = true;
			BlBump = false;
			BrBump = false;
		}

		if(getBumperValue(BLbumpSwitch) == 1)
		{
			setTouchLEDColor(BLtouch_LED, colorRed);
			setTouchLEDColor(MLtouch_LED, colorRed);
			setTouchLEDBlinkTime(FRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(BRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(BLtouch_LED, 1, 1);
			setTouchLEDBlinkTime(FLtouch_LED, 3, 3);
			setTouchLEDBlinkTime(MRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(MLtouch_LED, 1, 1);
			FRbrightValue = 255;
 			MRbrightValue = 255;
 			MLbrightValue = 255;
 			FLbrightValue = 255;
			BLbrightValue = 255;
			BRbrightValue = 255;

			BlBump = true;
			FBump = false;
			BrBump = false;
		}

		if(getBumperValue(BRbumpSwitch) == 1)
		{
			setTouchLEDColor(BRtouch_LED, colorRed);
			setTouchLEDColor(MRtouch_LED, colorRed);
			setTouchLEDBlinkTime(FRtouch_LED, 3, 3);
			setTouchLEDBlinkTime(BRtouch_LED, 1, 1);
			setTouchLEDBlinkTime(BLtouch_LED, 3, 3);
			setTouchLEDBlinkTime(FLtouch_LED, 3, 3);
			setTouchLEDBlinkTime(MRtouch_LED, 1, 1);
			setTouchLEDBlinkTime(MLtouch_LED, 3, 3);
			FRbrightValue = 255;
 			MRbrightValue = 255;
 			MLbrightValue = 255;
 			FLbrightValue = 255;
			BLbrightValue = 255;
			BRbrightValue = 255;

			BrBump = true;
			FBump = false;
			BlBump = false;
		}

		if(FBump == true)
		{
			if(getMotorEncoder(FRMotor)< 180)
			{
				FLSpeed = -100;
				FRSpeed = 100;
				BSpeed = 0;
			}
			else
			{
				FBump = false;
				resetMotorEncoder(BMotor);
				resetMotorEncoder(BMotor);
			  resetMotorEncoder(FLMotor);
		  	resetMotorEncoder(FRMotor);
			}
		}

		if(BlBump == true)
		{
			if(getMotorEncoder(FLMotor)< 180)
			{
				FLSpeed = 100;
				FRSpeed = 0;
				BSpeed = -100;
			}
			else
			{
				BlBump = false;
				resetMotorEncoder(BMotor);
			  resetMotorEncoder(BMotor);
			  resetMotorEncoder(FLMotor);
			  resetMotorEncoder(FRMotor);
			}
		}

		if(BrBump == true)
		{
			if(getMotorEncoder(BMotor)< 180)
			{
				FLSpeed = 0;
				FRSpeed = -100;
				BSpeed = 100;
			}
			else
			{
				BrBump = false;
				resetMotorEncoder(BMotor);
				resetMotorEncoder(BMotor);
		  	resetMotorEncoder(FLMotor);
		  	resetMotorEncoder(FRMotor);
			}
		}

		if(BlBump == false && FBump == false && BrBump == false)
		{
			setTouchLEDBlinkTime(FRtouch_LED, 1, 0);//turn all LEDs on
	    setTouchLEDBlinkTime(BRtouch_LED, 1, 0);
	  	setTouchLEDBlinkTime(BLtouch_LED, 1, 0);
	  	setTouchLEDBlinkTime(FLtouch_LED, 1, 0);
	  	setTouchLEDBlinkTime(MRtouch_LED, 1, 0);
	  	setTouchLEDBlinkTime(MLtouch_LED, 1, 0);
		}

//LED Color----------------------------------------------------------------------------------------------------------------------------------

		setTouchLEDBrightness(FRtouch_LED, FRbrightValue); //shift brightness
		setTouchLEDBrightness(MRtouch_LED, MRbrightValue);
		setTouchLEDBrightness(BRtouch_LED, BRbrightValue);
		setTouchLEDBrightness(BLtouch_LED, BLbrightValue);
		setTouchLEDBrightness(MLtouch_LED, MLbrightValue);
		setTouchLEDBrightness(FLtouch_LED, FLbrightValue);

		setMotorSpeed(FLMotor, FLSpeed); //run motors
		setMotorSpeed(FRMotor, FRSpeed);
		setMotorSpeed(BMotor,  BSpeed);


	}
}
