#pragma config(Sensor, port1,   FbumpSwitch,    sensorVexIQ_Touch)
#pragma config(Sensor, port12,  FRtouch_LED,    sensorVexIQ_LED)
#pragma config(Sensor, port3,   BRbumpSwitch,   sensorVexIQ_Touch)
#pragma config(Sensor, port8,   MRtouch_LED,    sensorVexIQ_LED)
#pragma config(Sensor, port10,  BRtouch_LED,    sensorVexIQ_LED)
#pragma config(Motor,  motor6,  FLMotor,        tmotorVexIQ, openLoop, encoder)
#pragma config(Motor,  motor7,  FRMotor,        tmotorVexIQ, openLoop, encoder)
#pragma config(Sensor, port4,   MLtouch_LED,    sensorVexIQ_LED)
#pragma config(Sensor, port9,   BLbumpSwitch,   sensorVexIQ_Touch)
#pragma config(Sensor, port5,  	FLtouch_LED,    sensorVexIQ_LED)
#pragma config(Motor,  motor11, BMotor,         tmotorVexIQ, openLoop, encoder)
#pragma config(Sensor, port2,  	BLtouch_LED,    sensorVexIQ_LED)


float FLSpeed = 0;
float FRSpeed = 0;
float BSpeed = 0;
float x = 0;
float y = 0;
float r = 0;
float turnRot = 0;
float deg = 0;
float colorHue = 0;
int bTick = 0;
int counter = 0;
int counter2 = 0;
int FRbrightValue = 0;
int MRbrightValue = 0;
int BRbrightValue = 0;
int BLbrightValue = 0;
int MLbrightValue = 0;
int FLbrightValue = 0;
bool recount = false;

task main()
{
	setMotorEncoderUnits(encoderDegrees);

	//loading circle--------------------------------------------------------------------------------------------------------------------------------
	for( int i=0; i<7; i=i+1)
	{
		setTouchLEDBrightness(FRtouch_LED, FRbrightValue); //shift brightness
		setTouchLEDBrightness(MRtouch_LED, MRbrightValue);
		setTouchLEDBrightness(BRtouch_LED, BRbrightValue);
		setTouchLEDBrightness(BLtouch_LED, BLbrightValue);
		setTouchLEDBrightness(MLtouch_LED, MLbrightValue);
		setTouchLEDBrightness(FLtouch_LED, FLbrightValue);
		counter = counter+1;
		switch(counter)
		{
			case 1:
				setTouchLEDHue(BLtouch_LED, 14.2);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 255;
				BRbrightValue = 0;
			break;

			case 2:
				setTouchLEDHue(MLtouch_LED, 28.3);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 255;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 3:
				setTouchLEDHue(FLtouch_LED, 42.5);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 4:
				setTouchLEDHue(FRtouch_LED, 56.7);
				FRbrightValue = 255;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 5:
				setTouchLEDHue(MRtouch_LED, 71);
				FRbrightValue = 0;
 				MRbrightValue = 255;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 6:
				setTouchLEDHue(BRtouch_LED, 85.1);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 255;
			break;

			default:
			break;
		}

		sleep(250);
	}

		sleep(500);
//--------------------------------------------------------------------------------------------------------------------------------------------------


	while(true)
	{
		srand(nSysTime);
		bTick = getMotorEncoder(BMotor);

		displayCenteredBigTextLine(0, "KIWI BOT");//Print to screen
		displayCenteredTextLine(2, "Left Stick for X & Y");
		displayCenteredTextLine(3, "Right Stick for");
		displayCenteredTextLine(4, "rotation");

		x = abs(getJoystickValue(ChB)); //Take stick input as deg
		y = abs(getJoystickValue(ChA));
		r = -1*getJoystickValue(ChC);
		deg = atan(y/x)* 180.0 / PI;//Convert joystick to degrees

		if(getJoystickValue(ChB) <0 && getJoystickValue(ChA) >= 0)
		{
			deg = 180 - deg;
		}
		if(getJoystickValue(ChB) <-0 && getJoystickValue(ChA) < -0)
		{
			deg = deg + 180;
		}
		if(getJoystickValue(ChB) >=0 && getJoystickValue(ChA) < -0)
		{
			deg = 360 - deg;
		}

		/*Original Formulas
		wheelSpeed[0] = y*sqrt(3)/2 + x/2 + r; // front-left
    wheelSpeed[1] = y*sqrt(3)/2 - x/2 - r; // front-right
    wheelSpeed[2] = x - r; // back-middle
    */
//Move wheels to deg
    FLSpeed = (-(sinDegrees(deg)*100)*(sqrt(3)/2)) - ((cosDegrees(deg)*100)/2) - r; // front-left
    FRSpeed  = (sinDegrees(deg)*100)*sqrt(3)/2 - (cosDegrees(deg)*100)/2 - r; // front-right
    BSpeed = (cosDegrees(deg)*100) - r; // back-middle

    if(getJoystickValue(ChB) == 0 && getJoystickValue(ChA) == 0 && getJoystickValue(ChC)!= 0)//spin in place
		{

			FLSpeed =  getJoystickValue(ChC);
    	FRSpeed  =  getJoystickValue(ChC);
    	BSpeed =  getJoystickValue(ChC);

    	counter2 = counter2 + 5;
    	if(counter2 > 100)
    	{
    		if(getJoystickValue(ChC) > 0)
    	{
    		colorHue = colorHue - 2;
    		counter = counter - 1;
    		recount = false;
    	}

    	if(getJoystickValue(ChC) < 0)
    	{

    		colorHue = colorHue + 2;
    		counter = counter + 1;
    		recount = false;
    	}

    	}

    		switch(counter)
		{
			case 1:
				setTouchLEDHue(BLtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 255;
				BRbrightValue = 0;
			break;

			case 2:
				setTouchLEDHue(MLtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 255;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 3:
				setTouchLEDHue(FLtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 4:
				setTouchLEDHue(FRtouch_LED, colorHue);
				FRbrightValue = 255;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 5:
				setTouchLEDHue(MRtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 255;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 6:
				setTouchLEDHue(BRtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 255;
			break;

			default:
			break;

		}

			if(counter>6)
		{
			counter = 1;
		}
		if(counter < 1)
		{
			counter = 6;
		}
		if(counter2> 100)
		{
			counter2 = 0;
		}
}
		else
		{

		turnRot = acos((BSpeed + r)/100)*180/PI;

		if(deg <= 45)//Divide stick into quad-------------------------------------------------------------------------------------------------------------------
		{
		  BRbrightValue = 0;
 			BLbrightValue = 0;
 			MLbrightValue = 0;
 			FLbrightValue = 0;
			FRbrightValue = deg * 5.66;
			MRbrightValue = 255-(deg * 5.66);
		}

		if(deg >45 && deg <= 90)
		{
 			MRbrightValue = 0;
		  BRbrightValue = 0;
 			BLbrightValue = 0;
 			MLbrightValue = 0;
			FRbrightValue = 255-(deg * 1.41);
			FLbrightValue = (deg-45) * 1.41;
		}

		if(deg >90 && deg <= 135)
		{
 			MRbrightValue = 0;
		  BRbrightValue = 0;
 			BLbrightValue = 0;
 			MLbrightValue = 0;
			FRbrightValue = 127.5-((deg-90) * 2.83);
			FLbrightValue = (deg -90) * 5.66;
		}

		if(deg >135 && deg <= 180)
		{
			FRbrightValue = 0;
 			MRbrightValue = 0;
		  BRbrightValue = 0;
 			BLbrightValue = 0;
			FLbrightValue = 255-((deg-135) * 5.66);
			MLbrightValue = (deg-135) * 5.66;
		}
		if(deg >180 && deg <= 225)
		{
			FRbrightValue = 0;
 			MRbrightValue = 0;
		  BRbrightValue = 0;
 			FLbrightValue = 0;
			BLbrightValue = (deg -180) * 5.66;
			MLbrightValue = 255-((deg-180) * 5.66);
		}

		if(deg >225 && deg <= 270)
		{
			FRbrightValue = 0;
 			MRbrightValue = 0;
 			MLbrightValue = 0;
 			FLbrightValue = 0;
			BLbrightValue = 255-(deg * 1.41);
			BRbrightValue = (deg-225) * 1.41;
		}

		if(deg >270 && deg <= 315)
		{
			FRbrightValue = 0;
 			MRbrightValue = 0;
 			MLbrightValue = 0;
 			FLbrightValue = 0;
			BLbrightValue = 127.5-((deg-270) * 2.83);
			BRbrightValue = (deg -270) * 5.66;
		}

		if(deg >315)
		{
			FRbrightValue = 0;
 			BLbrightValue = 0;
 			MLbrightValue = 0;
 			FLbrightValue = 0;
			BRbrightValue = 255-((deg-315) * 5.66);
			MRbrightValue = (deg-315) * 5.66;
		}

	}
//-----------------------------------------------------------------------------------------------------------------------------------------------------------
	if(colorHue > 254)//keep in a legal value
	{
		colorHue=1;
	}

	if(colorHue < 1)
	{
		colorHue = 254;
	}

	if(getJoystickValue(ChB) == 0 && getJoystickValue(ChA) == 0 && getJoystickValue(ChC) == 0)
		{
			FRbrightValue = 255;
 			BLbrightValue = 255;
 			MLbrightValue = 255;
 			FLbrightValue = 255;
			BRbrightValue = 255;
			MRbrightValue = 255;

			if(recount == false)
			{
				recount = true;
				counter = 0;
			}
			if(counter<7)
			{
				counter = counter + 1;
				switch(counter)
				{
			case 1:
				setTouchLEDHue(BLtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 255;
				BRbrightValue = 0;
			break;

			case 2:
				setTouchLEDHue(MLtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 255;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 3:
				setTouchLEDHue(FLtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 255;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 4:
				setTouchLEDHue(FRtouch_LED, colorHue);
				FRbrightValue = 255;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 5:
				setTouchLEDHue(MRtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 255;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 0;
			break;

			case 6:
				setTouchLEDHue(BRtouch_LED, colorHue);
				FRbrightValue = 0;
 				MRbrightValue = 0;
 				MLbrightValue = 0;
 				FLbrightValue = 0;
				BLbrightValue = 0;
				BRbrightValue = 255;
			break;

				case 7:
				FRbrightValue = 255;
 				MRbrightValue = 255;
 				MLbrightValue = 255;
 				FLbrightValue = 255;
				BLbrightValue = 255;
				BRbrightValue = 255;

			break;

			default:
			break;

				}
			}
		}

		setTouchLEDBrightness(FRtouch_LED, FRbrightValue); //shift brightness
		setTouchLEDBrightness(MRtouch_LED, MRbrightValue);
		setTouchLEDBrightness(BRtouch_LED, BRbrightValue);
		setTouchLEDBrightness(BLtouch_LED, BLbrightValue);
		setTouchLEDBrightness(MLtouch_LED, MLbrightValue);
		setTouchLEDBrightness(FLtouch_LED, FLbrightValue);

		setMotorSpeed(FLMotor, FLSpeed); //run motors
		setMotorSpeed(FRMotor, FRSpeed);
		setMotorSpeed(BMotor,  BSpeed);
	}
}
